;angular.module('Landers.angular')
    .factory('Runtime', ['Flat', function (Flat) {
        var cache = {};
        function runtime (scope, inhert){
            var prekey = '$runtime';

            if ( !cache[scope.$id] ) {
                if (inhert) {
                    scope.$runtime = scope.$runtime || {};
                } else {
                    scope.$runtime = {};
                }
                cache[scope.$id] = true;
            }
            this.__proto__ = Flat.make(scope[prekey], scope);
            this.watch = function(key, callback){
                key = prekey + '.' + key;
                return scope.$watch(key, callback);
            };
        }
        return {
            make:function(scope, inhert){
                return new runtime(scope, inhert);
            }
        };
    }]);